<script type="text/javascript">
    RED.nodes.registerType("mydb", {
        "category": "storage",
        "color": '#336791',
        "defaults": {
            "name": {
                "value": ""
            },
            "style": {
                "value": "mustache"
            },
            "substEnvVars": {
                "value": false
            },
            "query": {
                "value": "SELECT * FROM {{msg.tableName}};"
            },
            "mydbConfig": {
                "type": "mydbConfig",
                "required": true
            }
        },
        "inputs": 1,
        "outputs": 1,
        "icon": "postgres.png",
        "align": "left",
        "label": function () {
            return this.name || "mydb";
        },
        "labelStyle": function () {
            return this.name ? "node_label_italic" : "";
        },
        "oneditprepare": function () {
            if (typeof this.style === "undefined") {
                $("#node-input-style").val("mustache");
            }
            if (typeof this.substEnvVars === "undefined") {
                $("#node-input-substEnvVars").prop("checked", false);
            }
            this.editor = RED.editor.createEditor({
                "id": 'node-input-editor',
                "mode": 'ace/mode/sql',
                "value": $("#node-input-query").val()
            });
            this.editor.focus();
        },
        "oneditsave": function () {
            $("#node-input-query").val(this.editor.getValue());
            delete this.editor;
        }
    });
</script>
<script type="text/html" data-template-name="mydb">
    <div class="form-row">
        <label for="node-input-name"><i class="icon-tag"></i> <span>Name</span></label>
        <input type="text" id="node-input-name" placeholder="name"> </div>
    <div class="form-row">
        <label for="node-input-mydbConfig"><i class="fa fa-server"></i> <span>Server</span></label>
        <input type="text" id="node-input-mydbConfig">
    </div>
    <div class="form-row">
        <label for="node-input-style"><i class="fa fa-code"></i> <span>Style</span></label>
        <select id="node-input-style" style="width: auto;">
            <option value="mustache"  >Mustache</option>
            <option value="handlebars">Handlebars</option>
        </select>
    </div>
    <div class="form-row">
        <input type="checkbox" id="node-input-substEnvVars" style="display: inline-block; width: auto; vertical-align: top;">
        <label for="node-input-substEnvVars" style="width: auto;"> <span>Substitute environment variables (subflow properties)</span></label>
    </div>
    <div class="form-row" style="position: relative; margin-bottom: 0px;">
        <label for="node-input-query"><i class="fa fa-file-code-o"></i> <span>Query</span></label>
        <input type="hidden" id="node-input-query" autofocus="autofocus"> </div>
    <div class="form-row node-text-editor-row">
        <div style="height: 300px; min-height: 150px;" class="node-text-editor" id="node-input-editor"></div>
    </div>
</script>
<script type="text/html" data-help-name="mydb">
    <p>mydb is a Node-RED node allowing basic access to databases.</p>
    <p>At the moment, it supports only Postgres 🐘, but maybe in the future other
        DBs will be included.

    <h3>Properties</h3>

    <p>
        <b>Server:</b>
        Database connection to be used for the query.
    </p>
    <p>
        <b>Style:</b>
        Template style to be used by the query field. See the <a href="#mydb-help-queries"><i>Queries</i></a> section below for details.
    </p>
    <p>
        <b>Substitute environment variables:</b>
        Substitute environment variables in the <i>Query</i> field in the same manner as <a href="https://nodered.org/docs/user-guide/environment-variables">node properties of type <i>environment variable</i></a>.
        This is typically used to substitute subflow property values when <a href="https://nodered.org/docs/developing-flows/flow-structure#customising-subflows">customizing subflows</a>.
    </p>
    <p>
        Note that in Node-RED environment variables are substituted when a flow starts.
        This means that, outside a subflow, setting environment variables (e.g. in a Function node) will not have the desired effect.
        See <a href="https://discourse.nodered.org/t/how-to-set-env-variable/18612">this discussion</a> for details.
    </p>
    <p>
        <b>Query:</b>
        Query string or template. See the <a href="#mydb-help-queries"><i>Queries</i></a> section below for details.
    </p>

    <h3>Output</h3>
    <p><code>msg.payload</code> will contain the result object of the query.
        It has the following properties:
    </p>
    <ul>
        <li> <i>command</i>: The sql command that was executed (e.g. "SELECT", "UPDATE", etc.)</li>
        <li> <i>rowCount</i>: The number of rows affected by the SQL statement</li>
        <li> <i>oid</i>: The OID returned</li>
        <li> <i>rows</i>: An array of rows</li>
    </ul>

    <h3 id="mydb-help-queries">Queries</h3>
    <p>Two flavors of templatized queries are currently supported:</p>
    <ul>
        <li><a href="https://mustache.github.io/">Mustache</a>
        <li><a href="https://handlebarsjs.com/">Handlebars</a>
    </ul>

    <h3>Examples</h3>

    <p>Simple templated query:</p>
    <pre>SELECT *
FROM table
WHERE id = {{msg.id}}</pre>

    <p>Raw query string generated by a previous node:</p>
    <pre>{{{msg.completeRawQuery}}}</pre>

    <p>Query of a node inside a subflow having <code>SENSOR</code> property:</p>
    <pre>SELECT time, temperature
FROM sensor_values
WHERE sensor = '${SENSOR}';</pre>
</script>
